ObjectIdReferenceProperty
Date: 2016-12-04

com.fasterxml.jackson.databind.deser.impl

## Class ObjectIdReferenceProperty

- java.lang.Object
- - com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase
  - - com.fasterxml.jackson.databind.deser.SettableBeanProperty
    - - com.fasterxml.jackson.databind.deser.impl.ObjectIdReferenceProperty

- All Implemented Interfaces:
    BeanProperty, Named, java.io.Serializable

      public class ObjectIdReferenceProperty
      extends SettableBeanProperty

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ObjectIdReferenceProperty.PropertyReferring`

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `BeanProperty.Std`

  - ### Field Summary

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

    - ### Fields inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

      `_metadata, _propertyFormat`

    - ### Fields inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `EMPTY_FORMAT, EMPTY_INCLUDE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ObjectIdReferenceProperty(ObjectIdReferenceProperty src, JsonDeserializer<?> deser)`
    `ObjectIdReferenceProperty(ObjectIdReferenceProperty src, PropertyName newName)`
    `ObjectIdReferenceProperty(SettableBeanProperty forward, ObjectIdInfo objectIdInfo)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deserializeAndSet(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `java.lang.Object` | `deserializeSetAndReturn(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
    `void` | `fixAccess(DeserializationConfig config)` Method called to ensure that the mutator has proper access rights to be called, as per configuration.
    `<A extends java.lang.annotation.Annotation> A` | `getAnnotation(java.lang.Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `int` | `getCreatorIndex()` Method for accessing index of the creator property: for other types of properties will simply return -1.
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `void` | `set(java.lang.Object instance, java.lang.Object value)` Method called to assign given value to this property, on specified Object.
    `java.lang.Object` | `setAndReturn(java.lang.Object instance, java.lang.Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
    `SettableBeanProperty` | `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
    `SettableBeanProperty` | `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, _throwAsIOE, _throwAsIOE, assignIndex, depositSchemaProperty, deserialize, getContextAnnotation, getDeclaringClass, getFullName, getInjectableValueId, getManagedReferenceName, getName, getObjectIdInfo, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, getWrapperName, hasValueDeserializer, hasValueTypeDeserializer, hasViews, setManagedReferenceName, setObjectIdInfo, setViews, toString, visibleInView, withName, withSimpleName`

    - ### Methods inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

      `findFormatOverrides, findPropertyFormat, findPropertyInclusion, getMetadata, isRequired, isVirtual`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ObjectIdReferenceProperty

          public ObjectIdReferenceProperty(SettableBeanProperty forward,
                                   ObjectIdInfo objectIdInfo)

    - #### ObjectIdReferenceProperty

          public ObjectIdReferenceProperty(ObjectIdReferenceProperty src,
                                   JsonDeserializer<?> deser)

    - #### ObjectIdReferenceProperty

          public ObjectIdReferenceProperty(ObjectIdReferenceProperty src,
                                   PropertyName newName)

  - ### Method Detail

    - #### withValueDeserializer

          public SettableBeanProperty withValueDeserializer(JsonDeserializer<?> deser)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`
      Parameters:
        `deser` - Deserializer to assign to the new property instance
      Returns:
        Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

    - #### withName

          public SettableBeanProperty withName(PropertyName newName)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withName` in class `SettableBeanProperty`
      Parameters:
        `newName` - Name to use for the new instance.
      Returns:
        Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

    - #### fixAccess

          public void fixAccess(DeserializationConfig config)

      Description copied from class: `SettableBeanProperty`
      Method called to ensure that the mutator has proper access rights to be called, as per configuration. Overridden by implementations that have mutators that require access, fields and setters.
      Overrides:
        `fixAccess` in class `SettableBeanProperty`

    - #### getAnnotation

          public <A extends java.lang.annotation.Annotation> A getAnnotation(java.lang.Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

      Note that this method should only be called for custom annotations; access to standard Jackson annotations (or ones supported by alternate `AnnotationIntrospector`s) should be accessed through `AnnotationIntrospector`.

      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### getCreatorIndex

          public int getCreatorIndex()

      Description copied from class: `SettableBeanProperty`
      Method for accessing index of the creator property: for other types of properties will simply return -1.
      Overrides:
        `getCreatorIndex` in class `SettableBeanProperty`

    - #### deserializeAndSet

          public void deserializeAndSet(com.fasterxml.jackson.core.JsonParser p,
                               DeserializationContext ctxt,
                               java.lang.Object instance)
                                 throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### deserializeSetAndReturn

          public java.lang.Object deserializeSetAndReturn(com.fasterxml.jackson.core.JsonParser p,
                                                 DeserializationContext ctxt,
                                                 java.lang.Object instance)
                                                   throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.
      Specified by:
        `deserializeSetAndReturn` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### set

          public void set(java.lang.Object instance,
                 java.lang.Object value)
                   throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object.

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### setAndReturn

          public java.lang.Object setAndReturn(java.lang.Object instance,
                                      java.lang.Object value)
                                        throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `setAndReturn` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`